// (c) Copyright 2012 Cloudera, Inc. All rights reserved.
/*global define: false, $: false */
define([
	"cloudera/Util"
], function (Util) {
	"use strict";

	var AutoRefreshableCounter = function (element) {
		this.$element = $(element);
		this.delay = this.$element.attr("data-update-delay");
		this.url = this.$element.attr("data-update-href");

		var self = this;
		/**
		 * An external action that forces the counter to update.
		 */
		this.update = function () {
			this.autoUpdate();
		};

		this.autoUpdate = function () {
			// console.log("auto Update");
			var $element = this.$element;

			$.post(this.url, function (response) {
				var filteredResponse = Util.filterError(response);
				var counter = filteredResponse.data;
				if ($.isNumeric(counter)) {
					if (counter > 0) {
						$element.html("<span class='label label-important'>" + counter + "</span>");
					} else {
						$element.html("<span class='label'>0</span>");
					}
				} else {
					// TODO: Add error handling.
					console.log(response);
				}
			}, "json");
		};

		if (!Util.getTestMode()) {
			window.setInterval(function () {
				self.autoUpdate();
			}, 5000);
			self.autoUpdate();
		}
	};

	$.fn.AutoRefreshableCounter = function (option) {
		return this.each(function () {
			var $this = $(this),
				data = $this.data('AutoRefreshableCounter');

			if (!data) {
				$this.data('', (data = new AutoRefreshableCounter(this)));
			}
			if (option === 'update') {
				data.update();
			}
		});
	};

	return $.fn.AutoRefreshableCounter;
});
